/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.gearman.worker;

import org.gearman.Constants;
import org.gearman.common.GearmanPacket;
import org.gearman.common.PacketMagic;
import org.gearman.common.PacketType;
import org.gearman.common.Packet;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.ServerSocket;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

/**
 *
 * @author elambert
 */
public class GearmanWorkerJobServerSessionTest {

    GearmanWorkerJobServerSession session;
    ServerSocket s;

    @Before
    public void initTest() throws IOException {
        s = new ServerSocket(Constants.GEARMAN_DEFAULT_TCP_PORT - 1);
        session = new GearmanWorkerJobServerSession(new InetSocketAddress(Constants.GEARMAN_DEFAULT_TCP_PORT - 1));
    }
    
    @After
    public void shutDownTest() {
        try {
            s.close();
        } catch (IOException ioe) {} 
    }
    
    @Test 
    public void ctorTest() {
        Assert.assertTrue(session.isAwake());
        Assert.assertFalse(session.isInitialized());
        Assert.assertTrue(session.getNewJobs().isEmpty());
        Assert.assertFalse(session.isProcessingRequests());
        //Assert.assertEquals(session.DESCRIPTION_PREFIX + ":" + Thread.currentThread().getId(), session.toString());
    }

    public void sleepWakeTest() {
        session.setToSleep();
        Assert.assertFalse(session.isAwake());
        session.wakeSession();
        Assert.assertTrue(session.isAwake());
    }

    public void submitBadJobTest() {
        Assert.assertFalse(submitBadJob(null));
        Assert.assertEquals(0, session.getNewJobs().size());
        Assert.assertFalse(submitBadJob(new Packet(PacketMagic.REQ, PacketType.NOOP, new byte[0])));
        Assert.assertEquals(0, session.getNewJobs().size());
    }
    
    private boolean submitBadJob(Packet p) {
        try {
            session.addNewJob(p);
        } catch (IllegalArgumentException iae) {
            return false;
        }
        return true;
    }



}
